; blk9_asm

sd_linel	equ	$64

	in	win1_lib_hed1

	bra.s	start
	dc.l	0
	dc.w	$4afb
fname	dc.w	fname_e-fname-2
	dc.b	"blk v1.09"
fname_e	ds.b	0
	ds.w	0

	in	win1_ass_pe_keys_pe
	in	win1_ass_pe_qdos_pt
	in	win1_ass_pe_keys_wwork
	in	win1_ass_pe_keys_wstatus
	in	win1_ass_pe_keys_wman
	in	win1_ass_pe_keys_wdef

	rsset	0
id	rs.l	1
wmvec	rs.l	1
slimit	rs.w	4
x_sz	rs.w	1	size of window (Z)
y_sz	rs.w	1
x_or	rs.w	1	origin of window (P)
y_or	rs.w	1
qx0	rs.w	1	P + Z (1st value of Q)
qy0	rs.w	1
qmx	rs.w	1	minimum value for Q
qmy	rs.w	1
wkdef	rs.l	1
width	rs.w	1
bbase	rs.w	4	space for block info



*
start	lea	(a6,a5.l),a5	cleared stack -> A5
	lea	(a6,a4.l),a6	dataspace
	bsr	ope		open a con channel . .
	move.l	a0,id(a6) 	. . keep the ID
	moveq	#iop_pinf,d0
	moveq	#-1,d3
	bsr	tp3
	move.l	a1,wmvec(a6)	keep WM vector . .
	beq	sui	---->	. . wasn't there!
	movea.l	a1,a2		set WM vector in A2
	lea	slimit(a6),a1
	moveq	#iop_flim,d0	maximum size of window . .
	bsr	tp3
	moveq	#0,d1
	moveq	#0,d2
	moveq	#sd_wdef,d0
	bsr	tp3


	lea	wd0,a3		address of window definition
	move.l	#ww0_0,d1 	size of working definition . .
	bsr	getsp		. . sets ALCHP'd address to A0 . .
	movea.l	a0,a4		. . and to A4
	lea	wst0,a1		Clear the status . .
	movea.l	a1,a0		. . area . .
	moveq	#63,d1
st1	clr.b	(a0)+
	dbf	d1,st1


	move.w	(a7)+,d0		no of channels
	lsr.w	#2,d0
	lea	(a7,d0.w),a7	point to string
	move.w	(a7)+,d1		length of hex
	beq	sui4	---->	faulty parameter
	subq.w	#1,d1
	movea.l	a7,a1
	bsr	hex		set working def address to D5
	bne	sui4	---->
	movea.l	a5,a7		set stack

	move.l	d5,wkdef(a6)
	movea.l	d5,a0
	move.l	ww_xsize(a0),d0
	move.l	d0,x_sz(a6)
	move.l	d0,qx0(a6)
	move.l	ww_xorg(a0),d0
	move.l	d0,x_or(a6)
	add.l	d0,qx0(a6)


	add.l	#$60004,d0
	move.l	d0,qmx(a6)	Minimum value for Q


	movea.l	id(a6),a0 	Replace the channel ID
	subi.l	#$80000,slimit(a6)
	move.l	slimit(a6),d1	size

	lea	wst0,a1		status area
	jsr	wm_setup(a2)	Set up the working definition
	move.l	#$40000,d1	Set the window . .
	jsr	wm_prpos(a2)	. . at 4,0






; Set the pointer to Q

	move.l	qx0(a6),d1
	moveq	#0,d2		absolute co_ords
	moveq	#iop_sptr,d0	to set sprite position
	bsr	tp3


; First check that a mouse key is down.
; Then read the pointer until a move or mouse key up.

stretch	moveq	#0,d1
	moveq	#2,d2
	moveq	#-1,d3
	movea.l	(a4),a1
	lea	8(a1),a1		-> pointer record
	moveq	#iop_rptr,d0
	bsr	tp3
	move.l	d1,d7		1st pointer position

	bsr	blk
rp1	moveq	#12,d2
	moveq	#iop_rptr,d0
	bsr	tp3
	
	cmp.l	d1,d7
	bne	rp5


;	 cmp.w	 $12(a1),d7
;	 beq	 rp8

;	 bsr	 wait



rp7	bsr	blk
	bra	end		back to caller

rp5	moveq	#0,d5		set marker
	moveq	#2,d6		set "count"
rp2	cmp.w	qmx(a6,d6.w),d1
	bge	rp3		OK
	move.w	qmx(a6,d6.w),d1	constrain y/x value
	moveq	#1,d5		mark alteration
rp3	swap	d1
	subq.w	#2,d6		1st time D6.W = 0
	beq	rp2		go back for x
	cmp.w	ww_ysize(a4),d1	is y_size too big? . .
	ble	rp6		. . no
	move.w	ww_ysize(a4),d1
	moveq	#1,d5
rp6	tst.l	d5		constrained? . .
	beq	rp4		. . no
	moveq	#0,d2		absolute co-ordinates
	moveq	#iop_sptr,d0	to set sprite position
	bsr	tp3
rp4	cmp.l	d1,d7		moved? . .
	beq	rp1		. . no
	bsr	blk		draw block (from D7)
	move.l	d1,d7
	bsr	blk
	bra	rp1

;rp8	 bsr	 blp
;	 bra	 rp1

wait
	movem.l	d1/a1,-(sp)
wait1	moveq	#io_fbyte,d0
	bsr	tp3
	subi.b	#'1',d1
	bne	wait1
	movem.l	(sp)+,d1/a1
	rts


*

con	dc.w	3
	dc.b	'con'

ope	lea	con,a0		To open "con" . .
	moveq	#-1,d1		. . for this job
	moveq	#0,d3
	moveq	#io_open,d0
	trap	#2
	rts







tp3	trap	#3
	tst.l	d0
	bne	sui
	rts

bl_reg	reg	d0/d1/d3/d5-7/a1
blk	movem.l	bl_reg,-(sp)
	subi.l	#$40000,d7
	moveq	#sd_setmd,d0
	moveq	#-1,d1
	bsr	tp3
	move.w	d7,d5		qcy
	swap	d7
	move.w	d7,d6		qcx
	swap	d7
	lea	bbase(a6),a1
	move.w	d6,d0
	sub.w	x_or(a6),d0
	addq.w	#4,d0
	move.w	d0,(a1)
	move.w	#1,2(a1)
	move.l	x_or(a6),4(a1)
	subq.w	#4,4(a1)
	bsr	cb		-- top
	lea	bbase(a6),a1
	move.w	d5,6(a1)
	subq.w	#1,6(a1)
	bsr	cb		-- bottom
	lea	bbase(a6),a1
	move.w	#2,(a1)
	move.w	d5,d0
	sub.w	y_or(a6),d0
	subq.w	#2,d0
	move.w	d0,2(a1)
	move.w	y_or(a6),6(a1)
	addq.w	#1,6(a1)
	bsr	cb		| left
	lea	bbase(a6),a1
	move.w	d6,4(a1)
	subq.w	#2,4(a1)
	bpl	blk1
	addq.w	#1,4(a1)
blk1
	bsr	cb		| right
	movem.l	(sp)+,bl_reg
	rts

cb	moveq	#7,d1		white
	moveq	#sd_fill,d0
	bra	tp3

; Hex in A1 is set to decimal in D5
; D1 is the length	- 1 (<8)

HEX
	MOVEQ	#0,D5
HX_L	MOVE.B	(A1)+,D0	next byte
	SUBI.B	#"0",D0
	BMI.S	WRN_HX ---->
	CMPI.B	#9,D0
	BLE.S	D_HX
	SUBQ.B	#7,D0
	CMPI.B	#16,D0
	BLT.S	HX_1	capitals
	SUBI.B	#32,D0
HX_1	CMPI.B	#10,D0
	BLT.S	WRN_HX ---->
	CMPI.B	#15,D0
	BGT.S	WRN_HX ---->
D_HX	LSL.L	#4,D5	prepare for next nibble
	OR.B	D0,D5	put it in
	DBF	D1,HX_L
	moveq	#0,d0
	bra	hx_end
WRN_HX	MOVEQ	#-1,D0
HX_END
	RTS

; Extop routine to get linel

linl	move.w	sd_linel(a0),d1
	moveq	#0,d0
	rts

setl	lea	linl,a2
	moveq	#-1,d3
	moveq	#sd_extop,d0
	bsr	tp3
	move.w	d1,width(a6)
	rts

end	move.l	d7,d3		Qc
	sub.w	qy0(a6),d3
	swap	d3
	sub.w	qx0(a6),d3	alteration in size
	swap	d3
	bra	sui2		returns alteration in size

; sui1 returns no error
; sui2 returns what's in D3.L

sui4	moveq	#-15,d3		faulty parameter
	bra	sui2
sui3	moveq	#-19,d3		not implemented
	bra	sui2
sui1	moveq	#0,d3
sui2	moveq	#-1,d1
	moveq	#mt_frjob,d0
	trap	#1




	in	win1_ass_pe_rsz3_asm

	in	win1_ass_pe_peas_sym_lst
	lib	win1_ass_pe_peas_bin



	in	win1_ass_pe_csprc_sym_lst
	lib	win1_ass_pe_csprc_bin
